#!/usr/bin/perl

use warnings;
no warnings 'uninitialized', 'once';

use strict;

use FindBin qw($Bin $Script);
use File::Spec;
use Win32::Daemon::Simple
  Service => 'SERVICENAME',
  Name => 'SERVICE NAME',
  Version => 'x.x',
  Info => {
    display =>  'SERVICEDISPLAYNAME',
    description => 'SERVICEDESCRIPTION',
    user    =>  '',
    pwd     =>  '',
    interactive => 0,
#   parameters => "-- foo bar baz",
    },
  Params => { # the default parameters
    Tick => 0,
    Talkative => 0,
    Interval => 10, # minutes
    LogFile => "ServiceName.log",
    # ...
    Description => <<'*END*',
Tick : (0/1) controls whether the service writes a "tick" message to
  the log once a minute if there's nothing to do
Talkative : controls the amount of logging information
Interval : how often does the service look for new or modified files
  (in minutes)
LogFile : the path to the log file
...
*END*
    },
  Param_modify => {
    LogFile => sub {File::Spec->rel2abs($_[0])},
    Interval => sub {
    no warnings;
    my $interval = 0+$_[0];
    die "The interval must be a positive number!\n" unless $interval > 0;
    return $interval
  },
    Tick => sub {return ($_[0] ? 1 : 0)},
  },
  Run_params => { # parameters for this run of the service
    #...
  };

# initialization

ServiceLoop(\&doTheJob);

# cleanup

Log("Going down");
exit;

# definition of doTheJob()
# You may want to call DoEvents() within the doTheJob() at places where it
# would be safe to pause or stop the service if the processing takes a lot of time.
# Eg. DoEvents( \&close_db, \&open_db, sub {close_db(); cleanup();1})
sub doTheJob {
  print "Test";
}
